#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

#define OBF(x) (unsigned char)(x ^ 0x8f)

unsigned char good_pass[] = {
  OBF('D'),
  OBF('r'),
  OBF('g'),
  OBF('n'),
  OBF('S'),
  OBF('{'),
  OBF('W'),
  OBF('a'),
  OBF('a'),
  OBF('a'),
  OBF('y'),
  OBF('T'),
  OBF('o'),
  OBF('o'),
  OBF('E'),
  OBF('Z'),
  OBF('!'),
  OBF('!'),
  OBF('1'),
  OBF('}')
};

int main(int argc, char **argv) {
  if (argc != 2) {
    return 1;
  }

  const char *pass = argv[1];

  if (strlen(pass) != sizeof(good_pass)) {
    return 2;
  }

  for (size_t i = 0; i < sizeof(good_pass); i++) {
    if ((unsigned char)pass[i] != OBF(good_pass[i])) {
      return 3;
    }
  }

  return 0;
}

