import md5
import struct

def enc(d, code):
  d = bytearray(d)
  h = md5.md5(d).hexdigest().lower()
  print h

  data = bytearray(''.join([
    str(d),
    h
  ]))

  for i in xrange(len(data)):
    data[i] = ((data[i] + ((code >> 8) & 0xff)) & 0xff) ^ (code & 0xff)
    code = (code * 3505283827) & 0xffff

  return data

d = bytearray(open("oldskull_checker.exe", "rb").read())

# 5b42
# 13cc
# f129
# 62ac
# DrgnS{WaaayTooEZ!!1}

lvl4 = enc(d, 0x62ac)
lvl3 = enc(lvl4, 0xf129)
lvl2 = enc(lvl3, 0x13cc)
lvl1 = enc(lvl2, 0x5b42)

open("oldskull_checker.enc", "wb").write(lvl1)

with open("oldskull_checker.h", "w") as f:
  f.write("#pragma once\n")
  f.write("unsigned char oldskull_checker[] = {\n")
  first = True
  cnt = 0
  for c in lvl1:
    if first:
      first = False
    else:
      f.write(", ")
    f.write("0x%.2x" % c)
    if cnt == 16:
      f.write("\n")
      cnt = 0
    else:
      cnt += 1
  f.write("};")


